#include <iostream>

int main()
{
        int n,c,q;
        std::cin >> n >> c >> q;
        std::string s;
        int l[q];
        int r[q];
        std::cin >> s;
        for(int i=0;i<q;i++)
        {
                std::cin >> l[i] >> r[i];
        }
        if(n==c)
        {
                for(int j=0;j<q;j++)
                {
                        int m=r[j];
                        for(int k=l[j];k<=m;k++)
                                if(s[k-1]=='0')
                                        s[k-1] = '1';
                                else
                                        s[k-1] = '0';

                        int brkeca = 0;
                        for(int i=0;i<n;i++)
                                if(s[i]=='1')
                                        brkeca++;
                        std::cout << brkeca << std::endl;
                }
        }
        else
        if(c==1)
        {
                int resenje=0;
                for(int j=0;j<q;j++)
                {
                        resenje = 0;
                        int m=r[j];
                        for(int k=l[j];k<=m;k++)
                        {
                                if(s[k-1] == '1')
                                        s[k-1] = '1';
                                else
                                        s[k-1] = '0';
                        }
                        bool kecevi = true;
                        for(int i=0;i<n;i++)
                        {
                                if(s[i]=='1')
                                        kecevi = true;
                                if(kecevi)
                                        if(s[i]=='0')
                                        {
                                                kecevi=false;
                                                resenje++;
                                        }
                        }
                        if(kecevi)
                                resenje++;
                        std::cout << resenje << std::endl;
                        return 0;

//ako je c 2 onda ako je vise od 50% stvari u nizu kecevi vredi okrenuti, ako je 3 onda 66% itd.
//doci do prvog keca videti kolko je do kraja pa jedan manje od kraja itd.
                }
        }
        else
        {
                int resenje=0;
                bool reseno = false;
                for(int j=0;j<q;j++)
                {
                        resenje = 0;
                        int m=r[j];
                        for(int k=l[j];k<=m;k++)
                        {
                                if(s[k-1] == '0')
                                {
                                        s[k-1] = '1';
                                }
                                else
                                        s[k-1] = '0';
                        }
                        bool kecevi = false;
                        for(int i=0;i<n;i++)//ide kroz sve dok ne nadje keca da gleda dal moze niz da nadje
                        {
                                if(s[i]=='1')
                                {
                                        kecevi = true;
                                }
                                if(kecevi)
                                {
                                        for(int l=n;l>=i;l--)
                                        {
                                                int nule = 0;
                                                int kec = 0;
                                                for(int k=i;k<l;k++)
                                                {
                                                        if(s[k]=='0')
                                                                nule++;
                                                        else
                                                                kec++;
                                                }
                                                if(kec > c)
                                                {
                                                        if((float)kec/nule >= (float)1/c)
                                                        {
                                                                resenje+=c;
                                                                resenje+=nule;
                                                                i=l;
                                                                reseno = true;
                                                                break;
                                                        }
                                                }
                                                else
                                                {
                                                        resenje+=kec;
                                                        reseno = true;
                                                        i=l;
                                                        break;
                                                }

                                        }
                                        if(reseno)
                                                break;
                                }
                                else
                                {
                                //      resenje++;
                                }

                        }
                        std::cout << resenje << std::endl; 
                }
        }
        return 0;

}